chiark / gitweb /
dot/mc-panels.ini: More useful default.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
82c688c7 13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115done
852cd5fb 116echo " all done."
f617db13 117
ce178f96
MW
118###--------------------------------------------------------------------------
119### Install global configuration.
120
f141fe0f
MW
121echo -n "Installing dotfile configuration:"
122if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127fi
128
ce178f96 129## Symlink the various dotfiles into place
852cd5fb 130dotfiles="
be7dba95 131 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 132 emacs emacs-calc vm gnus.el ercrc.el
b0d8acbe 133 vimrc mg zile
30169591 134 ditz-config
b3468c3b 135 mailrc signature
ce178f96 136 cgrc tigrc
e7d23024 137 gdbinit
8a7e906d 138 guile
1d89ce86 139 rcrc
5d25e440 140 toprc
a6a6806a 141 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
cbffcf2b 142 aspell.conf
78719982 143 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
144 lisp-init.lisp:.cmucl-init.lisp
145 lisp-init.lisp:.sbclrc
146 lisp-init.lisp:.clisprc.lisp
f6335a0c 147 lisp-init.lisp:.eclrc
b5bf3445 148 swank.lisp
2425eca9 149 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 150[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 151 xinitrc xsession Xdefaults vncrc vncsession
5e23020b 152 fonts.conf
e517857c 153 stalonetrayrc
1c6b19d4 154 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 155 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 156 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 157 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 158 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 159 e16-bindings:.e16/bindings.cfg"
f617db13
MW
160echo "Installing dotfiles..."
161for d in $dotfiles; do
739bccbf
MW
162 target=.$d
163 case $d in
164 *:*) target=${d#*:} d=${d%%:*};;
165 esac
166 ft=$HOME$sub/$target
167 dir=${ft%/*}
168 mkdir -p $dir
99063107 169 ln -s $here/dot/$d $ft.new
739bccbf
MW
170 mv $ft.new $ft
171 echo " $target"
f617db13 172done
852cd5fb 173echo " all done."
f617db13 174
403dc178
MW
175## Substitute things which need substituting.
176dotfilessubst="
177 gitconfig
178 pulse-default.pa.in:.pulse/default.pa"
179echo "Installing dotfiles with substitutions..."
180for d in $dotfilessubst; do
181 case $d in
182 *:*) target=${d#*:} d=${d%%:*};;
183 *) target=.$d d=$d.in;;
184 esac
185 ft=$HOME$sub/$target
186 dir=${ft%/*}
187 mkdir -p $dir
188 sed "
2b5d4580
MW
1891i\\
190### generated by $here/setup; do not edit!\\
403dc178
MW
191
192/@home@/ s\a\a$HOME\ag
193/@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
194/@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
195" dot/$d >$ft.new
196 mv $ft.new $ft
197 echo " $target"
198done
199echo " all done."
200
f4e43257 201## Symlink backgrounds.
960af1a5
MW
202backgrounds="
203 jue-peek.jpg
204 medusa.jpg
5236501e 205 bsg-supper.jpg
960af1a5 206 rayne.jpg
56c871ef 207 hypatia.jpg
e1ca556b
MW
208 noodly.jpg
209 lovelace.jpg"
f4e43257
MW
210if [ "$xstuff" ]; then
211 echo "Installing backgrounds..."
212 for b in $backgrounds; do
213 for e in enlightenment e16; do
214 dir=$HOME$sub/.$e/backgrounds
215 t=$dir/$b
216 mkdir -p $dir
99063107 217 ln -s $here/bg/$b $t.new
f4e43257
MW
218 mv $t.new $t
219 done
220 echo " $b"
221 done
222 echo " all done."
223fi
224
ce178f96
MW
225###--------------------------------------------------------------------------
226### Install useful scripts included in this package.
227
e04c4857 228scripts="
547fb8af 229 mdw-editor
b20bfd83 230 mdw-pager
b056f5c4 231 mdw-conf
7ee12623 232 mdw-build
c4e84cb1 233 emacsclient-hack
8e08f814 234 movemail-hack
aaa2d943 235 sendmail-hack
68b2e9e6 236 aspell-hack
285a1386
MW
237 emerge-hack
238 lesspipe.sh
239 start-ssh-agent
4cdeb0d0
MW
240 svnwrap
241 hyperspec"
8e08f814 242[ "$xstuff" ] && scripts="$scripts
3bdada49 243 xinitcmd
34a5ea4e 244 un-backslashify-selection
c02999e8 245 lock-screen
8e08f814 246 xshutdown"
e04c4857
MW
247echo "Installing scripts..."
248mkdir -p $HOME$sub/bin
249for s in $scripts; do
250 ft=$HOME$sub/bin/$s
99063107 251 ln -s $here/bin/$s $ft.new
e04c4857
MW
252 mv $ft.new $ft
253 echo " $s"
254done
255echo " all done."
256
4d7d040b
MW
257hacks="
258 ssh:ssh"
259echo "Installing hacks..."
260for h in $hacks; do
261 d=${h%%:*} h=${h#*:}
262 ft=$HOME$sub/bin/hacks/$d
263 mkdir -p $ft
264 ln -s $here/hacks/$h $ft/$h.new
265 mv $ft/$h.new $ft/$h
266 echo " $d:$h"
267done
268echo " all done."
269
ce178f96
MW
270###--------------------------------------------------------------------------
271### Set up the Emacs config.
272
65ff0e8c
MW
273$echon "Finding a suitable emacs:$echoc"
274emacs=no
5fe24792 275for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
276 if type -p >/dev/null $i; then
277 emacs=$i
278 break
279 fi
280done
281if [ $emacs = no ]; then
282 echo " failed."
283 emacs=:
284else
285 echo " $emacs."
286fi
287
f617db13 288echo "Installing Emacs packages..."
400223a1
MW
289emacspkg="
290 make-regexp
a1293ade 291 ew-hols
a3bdb4d9 292 mdw-gnus-patch
1778b496 293 git git-blame vc-git stgit
400223a1
MW
294 quilt"
295for elib in $emacspkg; do
f617db13 296 $echon " $elib:$echoc"
65ff0e8c 297 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 298 (progn
852cd5fb
MW
299 (setq load-path (nconc load-path (list "~/lib/emacs")))
300 (kill-emacs (condition-case nil
301 (progn (load-library "'"$elib"'") 0)
20eb0692 302 (error 1))))'; then
f617db13
MW
303 echo " already installed."
304 else
99063107
MW
305 if [ -f el/$elib.el ]; then
306 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
307 else
308 $echon " downloading$echoc"
309 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
310 fi
f617db13
MW
311 $echon " compiling$echoc"
312 (cd $HOME$sub/lib/emacs;
65ff0e8c 313 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 314 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
315 echo " done."
316 fi
317done
852cd5fb 318echo " all done."
f617db13
MW
319
320$echon "Setting up Emacs configuration:$echoc"
321$echon " linking$echoc"
99063107 322for f in dot-emacs.el Makefile; do
f617db13 323 set -- $(echo $link | tr : ' ')
99063107
MW
324 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
325 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
326done
327$echon " compiling$echoc"
65ff0e8c 328make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 329echo " done."
ce178f96
MW
330
331###----- That's all, folks --------------------------------------------------